
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16A
;Program type             : Application
;Clock frequency          : 16.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega16A
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _d=R5

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_0x20003:
	.DB  0x3A,0x4,0x40,0x10,0x12,0x14,0x32,0xB6
	.DB  0x17,0x16,0x18,0x4,0x19,0x3,0x1A,0x7B
	.DB  0x3,0xA,0xC,0x0,0x3E,0x0,0x70,0x0
	.DB  0x71,0x0,0x72,0x11,0x73,0x0,0xA2,0x2
	.DB  0x11,0x0,0x7A,0x20,0x7B,0x1C,0x7C,0x28
	.DB  0x7D,0x3C,0x7E,0x55,0x7F,0x68,0x80,0x76
	.DB  0x81,0x80,0x82,0x88,0x83,0x8F,0x84,0x96
	.DB  0x85,0xA3,0x86,0xAF,0x87,0xC4,0x88,0xD7
	.DB  0x89,0xE8,0x13,0xE0,0x0,0x0,0x10,0x0
	.DB  0xD,0x0,0x14,0x20,0xA5,0x5,0xAB,0x7
	.DB  0x24,0x75,0x25,0x63,0x26,0xA5,0x9F,0x78
	.DB  0xA0,0x68,0xA1,0x3,0xA6,0xDF,0xA7,0xDF
	.DB  0xA8,0xF0,0xA9,0x90,0xAA,0x94,0x13,0xE5
	.DB  0xE,0x61,0xF,0x4B,0x16,0x2,0x1E,0x37
	.DB  0x21,0x2,0x22,0x91,0x29,0x7,0x33,0xB
	.DB  0x35,0xB,0x37,0x1D,0x38,0x71,0x39,0x2A
	.DB  0x3C,0x78,0x4D,0x40,0x4E,0x20,0x69,0xC
	.DB  0x6B,0x40,0x74,0x19,0x8D,0x4F,0x8E,0x0
	.DB  0x8F,0x0,0x90,0x0,0x91,0x0,0x92,0x0
	.DB  0x96,0x0,0x9A,0x80,0xB0,0x84,0xB1,0xC
	.DB  0xB2,0xE,0xB3,0x82,0xB8,0xA,0x43,0x14
	.DB  0x44,0xF0,0x45,0x34,0x46,0x58,0x47,0x28
	.DB  0x48,0x3A,0x59,0x88,0x5A,0x88,0x5B,0x44
	.DB  0x5C,0x67,0x5D,0x49,0x5E,0xE,0x64,0x4
	.DB  0x65,0x20,0x66,0x5,0x94,0x4,0x95,0x8
	.DB  0x6C,0xA,0x6D,0x55,0x6E,0x11,0x6F,0x9F
	.DB  0x6A,0x40,0x1,0x40,0x2,0x40,0x13,0xE7
	.DB  0x15,0x0,0x4F,0x80,0x50,0x80,0x51,0x0
	.DB  0x52,0x22,0x53,0x5E,0x54,0x80,0x58,0x9E
	.DB  0x41,0x8,0x3F,0x0,0x75,0x5,0x76,0xE1
	.DB  0x4C,0x0,0x77,0x1,0x3D,0xC2,0x4B,0x9
	.DB  0xC9,0xCC,0x41,0x38,0x56,0x40,0x34,0x11
	.DB  0x3B,0x2,0xA4,0x89,0x96,0x0,0x97,0x30
	.DB  0x98,0x20,0x99,0x30,0x9A,0x84,0x9B,0x29
	.DB  0x9C,0x3,0x9D,0x4C,0x9E,0x3F,0x78,0x4
	.DB  0x79,0x1,0xC8,0xF0,0x79,0xF,0xC8,0x0
	.DB  0x79,0x10,0xC8,0x7E,0x79,0xA,0xC8,0x80
	.DB  0x79,0xB,0xC8,0x1,0x79,0xC,0xC8,0xF
	.DB  0x79,0xD,0xC8,0x20,0x79,0x9,0xC8,0x80
	.DB  0x79,0x2,0xC8,0xC0,0x79,0x3,0xC8,0x40
	.DB  0x79,0x5,0xC8,0x30,0x79,0x26,0x9,0x3
	.DB  0x55,0x0,0x56,0x40,0x3B,0x42

__GLOBAL_INI_TBL:
	.DW  0x14E
	.DW  _change_reg
	.DW  _0x20003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.3 Standard
;Automatic Program Generator
; Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 12/9/2014
;Author  : Rassol
;Company :
;Comments:
;
;
;Chip type               : ATmega16A
;Program type            : Application
;AVR Core Clock frequency: 16.000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega16a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include "SCCB.h"
;#include "delay.h"
;// Declare your global variables here
;//char d;
;unsigned char d;
;void main(void)
; 0000 001F {

	.CSEG
_main:
; 0000 0020 // Declare your local variables here
; 0000 0021 
; 0000 0022 // Input/Output Ports initialization
; 0000 0023 // Port A initialization
; 0000 0024 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0025 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0026 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0027 DDRA=0xff;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
; 0000 0028 
; 0000 0029 // Port B initialization
; 0000 002A // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 002B // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 002C PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 002D DDRB=0x00;
	OUT  0x17,R30
; 0000 002E 
; 0000 002F // Port C initialization
; 0000 0030 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0031 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0032 PORTC=0x00;
	OUT  0x15,R30
; 0000 0033 DDRC=0x00;
	OUT  0x14,R30
; 0000 0034 
; 0000 0035 // Port D initialization
; 0000 0036 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0037 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0038 PORTD=0x00;
	OUT  0x12,R30
; 0000 0039 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 003A 
; 0000 003B // Timer/Counter 0 initialization
; 0000 003C // Clock source: System Clock
; 0000 003D // Clock value: Timer 0 Stopped
; 0000 003E // Mode: Normal top=0xFF
; 0000 003F // OC0 output: Disconnected
; 0000 0040 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0041 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0042 OCR0=0x00;
	OUT  0x3C,R30
; 0000 0043 
; 0000 0044 // Timer/Counter 1 initialization
; 0000 0045 // Clock source: System Clock
; 0000 0046 // Clock value: Timer1 Stopped
; 0000 0047 // Mode: Normal top=0xFFFF
; 0000 0048 // OC1A output: Discon.
; 0000 0049 // OC1B output: Discon.
; 0000 004A // Noise Canceler: Off
; 0000 004B // Input Capture on Falling Edge
; 0000 004C // Timer1 Overflow Interrupt: Off
; 0000 004D // Input Capture Interrupt: Off
; 0000 004E // Compare A Match Interrupt: Off
; 0000 004F // Compare B Match Interrupt: Off
; 0000 0050 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0051 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0052 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0053 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0054 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0055 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0056 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0057 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0058 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0059 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 005A 
; 0000 005B // Timer/Counter 2 initialization
; 0000 005C // Clock source: System Clock
; 0000 005D // Clock value: Timer2 Stopped
; 0000 005E // Mode: Normal top=0xFF
; 0000 005F // OC2 output: Disconnected
; 0000 0060 ASSR=0x00;
	OUT  0x22,R30
; 0000 0061 TCCR2=0x00;
	OUT  0x25,R30
; 0000 0062 TCNT2=0x00;
	OUT  0x24,R30
; 0000 0063 OCR2=0x00;
	OUT  0x23,R30
; 0000 0064 
; 0000 0065 // External Interrupt(s) initialization
; 0000 0066 // INT0: Off
; 0000 0067 // INT1: Off
; 0000 0068 // INT2: Off
; 0000 0069 MCUCR=0x00;
	OUT  0x35,R30
; 0000 006A MCUCSR=0x00;
	OUT  0x34,R30
; 0000 006B 
; 0000 006C // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 006D TIMSK=0x00;
	OUT  0x39,R30
; 0000 006E 
; 0000 006F // USART initialization
; 0000 0070 // USART disabled
; 0000 0071 UCSRB=0x00;
	OUT  0xA,R30
; 0000 0072 
; 0000 0073 // Analog Comparator initialization
; 0000 0074 // Analog Comparator: Off
; 0000 0075 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0076 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0077 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0078 
; 0000 0079 // ADC initialization
; 0000 007A // ADC disabled
; 0000 007B ADCSRA=0x00;
	OUT  0x6,R30
; 0000 007C 
; 0000 007D // SPI initialization
; 0000 007E // SPI disabled
; 0000 007F SPCR=0x00;
	OUT  0xD,R30
; 0000 0080 
; 0000 0081 // TWI initialization
; 0000 0082 // TWI disabled
; 0000 0083 TWCR=0x00;
	OUT  0x36,R30
; 0000 0084 InitSCCB();
	RCALL _InitSCCB
; 0000 0085 
; 0000 0086       // Place your code here
; 0000 0087 //                PORTD.0=1;
; 0000 0088 //             PORTD.1=1;
; 0000 0089 //             delay_ms(500);
; 0000 008A //              PORTD.0=0;
; 0000 008B //             PORTD.1=0;
; 0000 008C 
; 0000 008D 
; 0000 008E                while(1!=OV7670_init());//ov7660???
_0x3:
	RCALL _OV7670_init
	CPI  R30,LOW(0x1)
	BRNE _0x3
; 0000 008F                if(1==OV7670_init()) PORTD.0=1;
	RCALL _OV7670_init
	CPI  R30,LOW(0x1)
	BRNE _0x6
	SBI  0x12,0
; 0000 0090 
; 0000 0091                	if( 0 == rdOV7670Reg(0x0a,&d))	 /* read ID */
_0x6:
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL _rdOV7670Reg
	CPI  R30,0
	BRNE _0x9
; 0000 0092                   {
; 0000 0093                                                /* error*/
; 0000 0094                  PORTD.1=0;
	CBI  0x12,1
; 0000 0095                  }
; 0000 0096 
; 0000 0097 
; 0000 0098                 if(d==0x76) PORTD.1=1;
_0x9:
	LDI  R30,LOW(118)
	CP   R30,R5
	BRNE _0xC
	SBI  0x12,1
; 0000 0099           while (1)
_0xC:
_0xF:
; 0000 009A       {
; 0000 009B 
; 0000 009C 
; 0000 009D 
; 0000 009E 
; 0000 009F 
; 0000 00A0 
; 0000 00A1 
; 0000 00A2       };
	RJMP _0xF
; 0000 00A3 }
_0x12:
	RJMP _0x12
;
;
;
;#include "SCCB.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include "delay.h"
;
;#define CHANGE_REG_NUM 176
;
;const char change_reg[CHANGE_REG_NUM][2]=
;{
;    {0x3a, 0x04},
;    {0x40 , 0x10} ,
;    {0x12 , 0x14} ,
;    {0x32 , 0xb6} ,
;    {0x17 , 0x16} ,
;    {0x18 , 0x04} ,
;    {0x19 , 0x03} ,
;    {0x1a , 0x7b} ,//0x7a ,
;    {0x03 , 0x0a} ,//0x0a ,
;    {0x0c , 0x00} ,
;    {0x3e , 0x00} ,//
;    {0x70 , 0x00} ,
;    {0x71 , 0x00} ,
;    {0x72 , 0x11} ,
;    {0x73 , 0x00} ,//
;    {0xa2 , 0x02} ,
;    {0x11 , 0x00} ,
;    {0x7a , 0x20} ,
;    {0x7b , 0x1c} ,
;    {0x7c , 0x28} ,
;    {0x7d , 0x3c} ,
;    {0x7e , 0x55} ,
;    {0x7f , 0x68} ,
;    {0x80 , 0x76} ,
;    {0x81 , 0x80} ,
;    {0x82 , 0x88} ,
;    {0x83 , 0x8f} ,
;    {0x84 , 0x96} ,
;    {0x85 , 0xa3} ,
;    {0x86 , 0xaf} ,
;    {0x87 , 0xc4} ,
;    {0x88 , 0xd7} ,
;    {0x89 , 0xe8} ,
;    {0x13 , 0xe0} ,
;    {0x00 , 0x00} ,//AGC
;    {0x10 , 0x00} ,
;    {0x0d , 0x00} ,
;    {0x14 , 0x20} ,//0x38 , limit the max gain
;    {0xa5 , 0x05} ,
;    {0xab , 0x07} ,
;    {0x24 , 0x75} ,
;    {0x25 , 0x63} ,
;    {0x26 , 0xA5} ,
;    {0x9f , 0x78} ,
;    {0xa0 , 0x68} ,
;    {0xa1 , 0x03} ,//0x0b ,
;    {0xa6 , 0xdf} ,//0xd8 ,
;    {0xa7 , 0xdf} ,//0xd8 ,
;    {0xa8 , 0xf0} ,
;    {0xa9 , 0x90} ,
;    {0xaa , 0x94} ,
;    {0x13 , 0xe5} ,
;    {0x0e , 0x61} ,
;    {0x0f , 0x4b} ,
;    {0x16 , 0x02} ,
;    {0x1e , 0x37} ,//0x07 ,
;    {0x21 , 0x02} ,
;    {0x22 , 0x91} ,
;    {0x29 , 0x07} ,
;    {0x33 , 0x0b} ,
;    {0x35 , 0x0b} ,
;    {0x37 , 0x1d} ,
;    {0x38 , 0x71} ,
;    {0x39 , 0x2a} ,//
;    {0x3c , 0x78} ,
;    {0x4d , 0x40} ,
;    {0x4e , 0x20} ,
;    {0x69 , 0x0c} ,///////////////////////
;    {0x6b , 0x40} ,//PLL
;    {0x74 , 0x19} ,
;    {0x8d , 0x4f} ,
;    {0x8e , 0x00} ,
;    {0x8f , 0x00} ,
;    {0x90 , 0x00} ,
;    {0x91 , 0x00} ,
;    {0x92 , 0x00} ,//0x19 ,//0x66
;    {0x96 , 0x00} ,
;    {0x9a , 0x80} ,
;    {0xb0 , 0x84} ,
;    {0xb1 , 0x0c} ,
;    {0xb2 , 0x0e} ,
;    {0xb3 , 0x82} ,
;    {0xb8 , 0x0a} ,
;    {0x43 , 0x14} ,
;    {0x44 , 0xf0} ,
;    {0x45 , 0x34} ,
;    {0x46 , 0x58} ,
;    {0x47 , 0x28} ,
;    {0x48 , 0x3a} ,
;    {0x59 , 0x88} ,
;    {0x5a , 0x88} ,
;    {0x5b , 0x44} ,
;    {0x5c , 0x67} ,
;    {0x5d , 0x49} ,
;    {0x5e , 0x0e} ,
;    {0x64 , 0x04} ,
;    {0x65 , 0x20} ,
;    {0x66 , 0x05} ,
;    {0x94 , 0x04} ,
;    {0x95 , 0x08} ,
;    {0x6c , 0x0a} ,
;    {0x6d , 0x55} ,
;    {0x6e , 0x11} ,
;    {0x6f , 0x9f} ,//0x9e for advance AWB
;    {0x6a , 0x40} ,
;    {0x01 , 0x40} ,
;    {0x02 , 0x40} ,
;    {0x13 , 0xe7} ,
;    {0x15 , 0x00} ,
;    {0x4f , 0x80} ,
;    {0x50 , 0x80} ,
;    {0x51 , 0x00} ,
;    {0x52 , 0x22} ,
;    {0x53 , 0x5e} ,
;    {0x54 , 0x80} ,
;    {0x58 , 0x9e} ,
;    {0x41 , 0x08} ,
;    {0x3f , 0x00} ,
;    {0x75 , 0x05} ,
;    {0x76 , 0xe1} ,
;    {0x4c , 0x00} ,
;    {0x77 , 0x01} ,
;    {0x3d , 0xc2} ,    //0xc0 ,
;    {0x4b , 0x09} ,
;    {0xc9 , 0xcc} ,
;    {0x41 , 0x38} ,
;    {0x56 , 0x40} ,//0x40 ,  change according to Jim's request
;    {0x34 , 0x11} ,
;    {0x3b , 0x02} ,//0x00 ,//0x02 ,
;    {0xa4 , 0x89} ,//0x88 ,
;    {0x96 , 0x00} ,
;    {0x97 , 0x30} ,
;    {0x98 , 0x20} ,
;    {0x99 , 0x30} ,
;    {0x9a , 0x84} ,
;    {0x9b , 0x29} ,
;    {0x9c , 0x03} ,
;    {0x9d , 0x4c} ,
;    {0x9e , 0x3f} ,
;    {0x78 , 0x04} ,
;    {0x79 , 0x01} ,
;    {0xc8 , 0xf0} ,
;    {0x79 , 0x0f} ,
;    {0xc8 , 0x00} ,
;    {0x79 , 0x10} ,
;    {0xc8 , 0x7e} ,
;    {0x79 , 0x0a} ,
;    {0xc8 , 0x80} ,
;    {0x79 , 0x0b} ,
;    {0xc8 , 0x01} ,
;    {0x79 , 0x0c} ,
;    {0xc8 , 0x0f} ,
;    {0x79 , 0x0d} ,
;    {0xc8 , 0x20} ,
;    {0x79 , 0x09} ,
;    {0xc8 , 0x80} ,
;    {0x79 , 0x02} ,
;    {0xc8 , 0xc0} ,
;    {0x79 , 0x03} ,
;    {0xc8 , 0x40} ,
;    {0x79 , 0x05} ,
;    {0xc8 , 0x30} ,
;    {0x79 , 0x26} ,
;    {0x09 , 0x03} ,
;    {0x55 , 0x00} ,
;    {0x56 , 0x40} ,
;    {0x3b , 0x42} ,//0x82 ,//0xc0 ,//0xc2 ,    //night mode
;
;
;    /*ΪOV7725QVGA RGB565ѥ`
;
;  {0x32 ,0x00} ,
;  {0x2a ,0x00} ,
;  {0x11 ,0x01} ,
;  {0x12 ,0x46} ,//QVGA RGB565
;  {0x12 ,0x46} ,
;
;  {0x09 ,0x03} ,
;  {0x42 ,0x7f} ,
;  {0x4d ,0x00} ,//0x09
;  {0x63 ,0xf0} ,
;  {0x64 ,0xff} ,
;  {0x65 ,0x20} ,
;  {0x66 ,0x00} ,
;  {0x67 ,0x00} ,
;  {0x69 ,0x5d} ,
;
;
;  {0x13 ,0xff} ,
;  {0x0d ,0x41} ,//PLL
;  {0x0f ,0xc5} ,
;  {0x14 ,0x11} ,
;  {0x22 ,0xFF} ,//7f
;  {0x23 ,0x01} ,
;  {0x24 ,0x34} ,
;  {0x25 ,0x3c} ,
;  {0x26 ,0xa1} ,
;  {0x2b ,0x00} ,
;  {0x6b ,0xaa} ,
;  {0x13 ,0xff} ,
;
;  {0x90 ,0x0a} ,//
;  {0x91 ,0x01} ,//
;  {0x92 ,0x01} ,//
;  {0x93 ,0x01} ,
;
;  {0x94 ,0x5f} ,
;  {0x95 ,0x53} ,
;  {0x96 ,0x11} ,
;  {0x97 ,0x1a} ,
;  {0x98 ,0x3d} ,
;  {0x99 ,0x5a} ,
;  {0x9a ,0x1e} ,
;
;  {0x9b ,0x00} ,//set luma
;  {0x9c ,0x25} ,//set contrast
;  {0xa7 ,0x65} ,//set saturation
;  {0xa8 ,0x65} ,//set saturation
;  {0xa9 ,0x80} ,//set hue
;  {0xaa ,0x80} ,//set hue
;
;  {0x9e ,0x81} ,
;  {0xa6 ,0x06} ,
;
;  {0x7e ,0x0c} ,
;  {0x7f ,0x16} ,
;  {0x80 ,0x2a} ,
;  {0x81 ,0x4e} ,
;  {0x82 ,0x61} ,
;  {0x83 ,0x6f} ,
;  {0x84 ,0x7b} ,
;  {0x85 ,0x86} ,
;  {0x86 ,0x8e} ,
;  {0x87 ,0x97} ,
;  {0x88 ,0xa4} ,
;  {0x89 ,0xaf} ,
;  {0x8a ,0xc5} ,
;  {0x8b ,0xd7} ,
;  {0x8c ,0xe8} ,
;  {0x8d ,0x20} ,
;
;  {0x33 ,0x00} ,
;  {0x22 ,0x99} ,
;  {0x23 ,0x03} ,
;  {0x4a ,0x00} ,
;  {0x49 ,0x13} ,
;  {0x47 ,0x08} ,
;  {0x4b ,0x14} ,
;  {0x4c ,0x17} ,
;  {0x46 ,0x05} ,
;  {0x0e ,0x75} ,
;  {0x0c ,0xd0} ,
;  	*/
;};

	.DSEG
;
;void InitSCCB(void)
; 0001 010B {

	.CSEG
_InitSCCB:
; 0001 010C     SCCB_DDR|=(1<<SCCB_SIO_C)|(1<<SCCB_SIO_D);
	IN   R30,0x17
	ORI  R30,LOW(0x6)
	OUT  0x17,R30
; 0001 010D     SCCB_PORT|=(1<<SCCB_SIO_C)|(1<<SCCB_SIO_D);
	IN   R30,0x18
	ORI  R30,LOW(0x6)
	OUT  0x18,R30
; 0001 010E }
	RET
;
;void startSCCB(void)
; 0001 0111 {
_startSCCB:
; 0001 0112     SIO_D_SET;
	RCALL SUBOPT_0x0
; 0001 0113     delay_us(100);
; 0001 0114 
; 0001 0115     SIO_C_SET;
; 0001 0116     delay_us(100);
; 0001 0117 
; 0001 0118     SIO_D_CLR;
	CBI  0x18,2
; 0001 0119     delay_us(100);
	RCALL SUBOPT_0x1
; 0001 011A 
; 0001 011B     SIO_C_CLR;
	CBI  0x18,1
; 0001 011C     delay_us(100);
	RJMP _0x2000004
; 0001 011D 
; 0001 011E 
; 0001 011F }
;
;void stopSCCB(void)
; 0001 0122 {
_stopSCCB:
; 0001 0123     SIO_D_CLR;
	CBI  0x18,2
; 0001 0124     delay_us(100);
	RCALL SUBOPT_0x2
; 0001 0125 
; 0001 0126     SIO_C_SET;
; 0001 0127     delay_us(100);
; 0001 0128 
; 0001 0129 
; 0001 012A     SIO_D_SET;
	SBI  0x18,2
; 0001 012B     delay_us(100);
	RJMP _0x2000004
; 0001 012C  //   SCCB_DDR&= ~(SCCB_SIO_D);
; 0001 012D 
; 0001 012E }
;
;
;void noAck(void)
; 0001 0132 {
_noAck:
; 0001 0133 
; 0001 0134     SIO_D_SET;
	RCALL SUBOPT_0x0
; 0001 0135     delay_us(100);
; 0001 0136 
; 0001 0137     SIO_C_SET;
; 0001 0138     delay_us(100);
; 0001 0139 
; 0001 013A     SIO_C_CLR;
	CBI  0x18,1
; 0001 013B     delay_us(100);
	RCALL SUBOPT_0x1
; 0001 013C 
; 0001 013D     SIO_D_CLR;
	CBI  0x18,2
; 0001 013E     delay_us(100);
_0x2000004:
	__DELAY_USW 400
; 0001 013F 
; 0001 0140 }
	RET
;
;uchar SCCBwriteByte(uchar m_data)
; 0001 0143 {
_SCCBwriteByte:
; 0001 0144     unsigned char j,tem;
; 0001 0145 
; 0001 0146     for(j=0;j<8;j++)
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	m_data -> Y+2
;	j -> R17
;	tem -> R16
	LDI  R17,LOW(0)
_0x20005:
	CPI  R17,8
	BRSH _0x20006
; 0001 0147     {
; 0001 0148         if((m_data<<j)&0x80)
	LDD  R26,Y+2
	LDI  R27,0
	MOV  R30,R17
	CALL __LSLW12
	ANDI R30,LOW(0x80)
	BREQ _0x20007
; 0001 0149         {
; 0001 014A             SIO_D_SET;
	SBI  0x18,2
; 0001 014B         }
; 0001 014C         else
	RJMP _0x20008
_0x20007:
; 0001 014D         {
; 0001 014E             SIO_D_CLR;
	CBI  0x18,2
; 0001 014F         }
_0x20008:
; 0001 0150         delay_us(100);
	RCALL SUBOPT_0x2
; 0001 0151         SIO_C_SET;
; 0001 0152         delay_us(100);
; 0001 0153         SIO_C_CLR;
	CBI  0x18,1
; 0001 0154         delay_us(100);
	RCALL SUBOPT_0x1
; 0001 0155 
; 0001 0156     }
	SUBI R17,-1
	RJMP _0x20005
_0x20006:
; 0001 0157     delay_us(100);
	RCALL SUBOPT_0x1
; 0001 0158 
; 0001 0159     SIO_D_IN;
	CBI  0x17,2
; 0001 015A     delay_us(100);
	RCALL SUBOPT_0x1
; 0001 015B     SIO_C_SET;
	SBI  0x18,1
; 0001 015C     delay_us(1000);
	__DELAY_USW 4000
; 0001 015D     if(SIO_D_STATE)
	IN   R30,0x16
	ANDI R30,LOW(0x4)
	CPI  R30,LOW(0x4)
	BRNE _0x20009
; 0001 015E     {
; 0001 015F         tem=0;
	LDI  R16,LOW(0)
; 0001 0160     }
; 0001 0161     else
	RJMP _0x2000A
_0x20009:
; 0001 0162     {
; 0001 0163         tem=1;
	LDI  R16,LOW(1)
; 0001 0164     }
_0x2000A:
; 0001 0165     SIO_C_CLR;
	CBI  0x18,1
; 0001 0166     delay_us(100);
	RCALL SUBOPT_0x1
; 0001 0167     SIO_D_OUT;
	SBI  0x17,2
; 0001 0168 
; 0001 0169     return(tem);
	MOV  R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x2000003
; 0001 016A }
;
;
;uchar SCCBreadByte(void)
; 0001 016E {
_SCCBreadByte:
; 0001 016F     unsigned char read,j;
; 0001 0170     read=0x00;
	ST   -Y,R17
	ST   -Y,R16
;	read -> R17
;	j -> R16
	LDI  R17,LOW(0)
; 0001 0171 
; 0001 0172     SIO_D_IN;
	CBI  0x17,2
; 0001 0173     delay_us(100);
	RCALL SUBOPT_0x1
; 0001 0174     for(j=8;j>0;j--)
	LDI  R16,LOW(8)
_0x2000C:
	CPI  R16,1
	BRLO _0x2000D
; 0001 0175     {
; 0001 0176         delay_us(100);
	RCALL SUBOPT_0x2
; 0001 0177         SIO_C_SET;
; 0001 0178         delay_us(100);
; 0001 0179         read=read<<1;
	LSL  R17
; 0001 017A         if(SIO_D_STATE)
	IN   R30,0x16
	ANDI R30,LOW(0x4)
	CPI  R30,LOW(0x4)
	BRNE _0x2000E
; 0001 017B         {
; 0001 017C             read=read+1;
	SUBI R17,-LOW(1)
; 0001 017D         }
; 0001 017E         SIO_C_CLR;
_0x2000E:
	CBI  0x18,1
; 0001 017F         delay_us(100);
	RCALL SUBOPT_0x1
; 0001 0180     }
	SUBI R16,1
	RJMP _0x2000C
_0x2000D:
; 0001 0181     SIO_D_OUT;
	SBI  0x17,2
; 0001 0182     return(read);
	MOV  R30,R17
	LD   R16,Y+
	LD   R17,Y+
	RET
; 0001 0183 }
;
;
;uchar rdOV7670Reg(uchar regID, uchar *regDat)
; 0001 0187 {
_rdOV7670Reg:
; 0001 0188 	startSCCB();
	ST   -Y,R27
	ST   -Y,R26
;	regID -> Y+2
;	*regDat -> Y+0
	RCALL SUBOPT_0x3
; 0001 0189 	if(0==SCCBwriteByte(0x42))
	BRNE _0x2000F
; 0001 018A 	{
; 0001 018B 		stopSCCB();
	RCALL _stopSCCB
; 0001 018C 		return(0);
	LDI  R30,LOW(0)
	RJMP _0x2000003
; 0001 018D 	}
; 0001 018E 	delay_us(100);
_0x2000F:
	RCALL SUBOPT_0x1
; 0001 018F   	if(0==SCCBwriteByte(regID))
	LDD  R26,Y+2
	RCALL _SCCBwriteByte
	CPI  R30,0
	BRNE _0x20010
; 0001 0190 	{
; 0001 0191 		stopSCCB();
	RCALL _stopSCCB
; 0001 0192 		return(0);
	LDI  R30,LOW(0)
	RJMP _0x2000003
; 0001 0193 	}
; 0001 0194 	stopSCCB();
_0x20010:
	RCALL _stopSCCB
; 0001 0195 
; 0001 0196 	delay_us(100);
	RCALL SUBOPT_0x1
; 0001 0197 
; 0001 0198 
; 0001 0199 	startSCCB();
	RCALL _startSCCB
; 0001 019A 	if(0==SCCBwriteByte(0x43))
	LDI  R26,LOW(67)
	RCALL _SCCBwriteByte
	CPI  R30,0
	BRNE _0x20011
; 0001 019B 	{
; 0001 019C 		stopSCCB();
	RCALL _stopSCCB
; 0001 019D 		return(0);
	LDI  R30,LOW(0)
	RJMP _0x2000003
; 0001 019E 	}
; 0001 019F 	delay_us(100);
_0x20011:
	RCALL SUBOPT_0x1
; 0001 01A0   	*regDat=SCCBreadByte();
	RCALL _SCCBreadByte
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
; 0001 01A1   	noAck();
	RCALL _noAck
; 0001 01A2   	stopSCCB();
	RCALL _stopSCCB
; 0001 01A3   	return(1);
	LDI  R30,LOW(1)
_0x2000003:
	ADIW R28,3
	RET
; 0001 01A4 }
;
;
;uchar wrOV7670Reg(uchar regID, uchar regDat)
; 0001 01A8 {
_wrOV7670Reg:
; 0001 01A9 	startSCCB();
	ST   -Y,R26
;	regID -> Y+1
;	regDat -> Y+0
	RCALL SUBOPT_0x3
; 0001 01AA 	if(0==SCCBwriteByte(0x42))
	BRNE _0x20012
; 0001 01AB 	{
; 0001 01AC 		stopSCCB();
	RCALL _stopSCCB
; 0001 01AD 		return(0);
	LDI  R30,LOW(0)
	RJMP _0x2000002
; 0001 01AE 	}
; 0001 01AF 	delay_us(100);
_0x20012:
	RCALL SUBOPT_0x1
; 0001 01B0   	if(0==SCCBwriteByte(regID))
	LDD  R26,Y+1
	RCALL _SCCBwriteByte
	CPI  R30,0
	BRNE _0x20013
; 0001 01B1 	{
; 0001 01B2 		stopSCCB();
	RCALL _stopSCCB
; 0001 01B3 		return(0);
	LDI  R30,LOW(0)
	RJMP _0x2000002
; 0001 01B4 	}
; 0001 01B5 	delay_us(100);
_0x20013:
	RCALL SUBOPT_0x1
; 0001 01B6   	if(0==SCCBwriteByte(regDat))
	LD   R26,Y
	RCALL _SCCBwriteByte
	CPI  R30,0
	BRNE _0x20014
; 0001 01B7 	{
; 0001 01B8 		stopSCCB();
	RCALL _stopSCCB
; 0001 01B9 		return(0);
	LDI  R30,LOW(0)
	RJMP _0x2000002
; 0001 01BA 	}
; 0001 01BB   	stopSCCB();
_0x20014:
	RCALL _stopSCCB
; 0001 01BC 
; 0001 01BD   	return(1);
	LDI  R30,LOW(1)
_0x2000002:
	ADIW R28,2
	RET
; 0001 01BE }
;
;uchar OV7670_init(void)
; 0001 01C1 {
_OV7670_init:
; 0001 01C2 	uchar temp;
; 0001 01C3 
; 0001 01C4 	uint i=0;
; 0001 01C5 
; 0001 01C6 
; 0001 01C7 	InitSCCB();//io init..
	CALL __SAVELOCR4
;	temp -> R17
;	i -> R18,R19
	__GETWRN 18,19,0
	RCALL _InitSCCB
; 0001 01C8 
; 0001 01C9 	temp=0x80;
	LDI  R17,LOW(128)
; 0001 01CA 	if(0==wrOV7670Reg(0x12, temp)) //Reset SCCB
	LDI  R30,LOW(18)
	ST   -Y,R30
	MOV  R26,R17
	RCALL _wrOV7670Reg
	CPI  R30,0
	BRNE _0x20015
; 0001 01CB 	{
; 0001 01CC 		return 0 ;
	LDI  R30,LOW(0)
	RJMP _0x2000001
; 0001 01CD 	}
; 0001 01CE 	delay_ms(10);
_0x20015:
	LDI  R26,LOW(10)
	LDI  R27,0
	CALL _delay_ms
; 0001 01CF 
; 0001 01D0           for(i=0;i<CHANGE_REG_NUM;i++)
	__GETWRN 18,19,0
_0x20017:
	__CPWRN 18,19,176
	BRSH _0x20018
; 0001 01D1 	{
; 0001 01D2 		if( 0==wrOV7670Reg(change_reg[i][0],change_reg[i][1]))
	MOVW R30,R18
	LDI  R26,LOW(_change_reg)
	LDI  R27,HIGH(_change_reg)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	MOVW R30,R18
	LDI  R26,LOW(_change_reg)
	LDI  R27,HIGH(_change_reg)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Z+1
	RCALL _wrOV7670Reg
	CPI  R30,0
	BRNE _0x20019
; 0001 01D3 		{
; 0001 01D4 			return 0;
	LDI  R30,LOW(0)
	RJMP _0x2000001
; 0001 01D5 		}
; 0001 01D6 	}
_0x20019:
	__ADDWRN 18,19,1
	RJMP _0x20017
_0x20018:
; 0001 01D7 
; 0001 01D8 
; 0001 01D9 
; 0001 01DA 
; 0001 01DB   //  OV7670_config_window(272,12,320,240);
; 0001 01DC 
; 0001 01DD 	return 0x01; //ok
	LDI  R30,LOW(1)
_0x2000001:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
; 0001 01DE 
; 0001 01DF 
; 0001 01E0 }

	.DSEG
_change_reg:
	.BYTE 0x160

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	SBI  0x18,2
	__DELAY_USW 400
	SBI  0x18,1
	__DELAY_USW 400
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x1:
	__DELAY_USW 400
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	RCALL SUBOPT_0x1
	SBI  0x18,1
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	RCALL _startSCCB
	LDI  R26,LOW(66)
	RCALL _SCCBwriteByte
	CPI  R30,0
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
